/* $Id: ObitTableIDI_ARRAY_GEOMETRY.h 123 2009-09-04 11:26:14Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#ifndef OBITTABLEIDI_ARRAY_GEOMETRY_H 
#define OBITTABLEIDI_ARRAY_GEOMETRY_H 

#include "Obit.h"
#include "ObitErr.h"
#include "ObitTable.h"
#include "ObitData.h"

/*-------- Obit: Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_ARRAY_GEOMETRY.h
 * ObitTableIDI_ARRAY_GEOMETRY class definition.
 *
 * This class is derived from the #ObitTable class.
 *
 * This class contains tabular data and allows access.
 * This table is part of the IDI uv data format.
 * IDI\_ARRAY\_GEOMETRY contains information about the locations 
 * of antennas in a UV data set.
 * Also time information and the state of the Earth's orientation.
 * Only FITS cataloged data are supported.
 * ]
 * \tableover
 * In memory tables are stored in a fashion similar to how they are 
 * stored on disk - in large blocks in memory rather than structures.
 * Due to the word alignment requirements of some machines, they are 
 * stored by order of the decreasing element size: 
 * double, float long, int, short, char rather than the logical order.
 * The details of the storage in the buffer are kept in the 
 * ObitTableDesc.
 * 
 *
 * This class contains tabular data and allows access.
 * "IDI_ARRAY_GEOMETRY" table
 * An ObitTableIDI_ARRAY_GEOMETRY is the front end to a persistent disk resident structure.
 * Only FITS (as Tables) are supported.
 *
 * \section TableDataStorage Table data storage
 * In memory tables are stored in a fashion similar to how they are 
 * stored on disk - in large blocks in memory rather than structures.
 * Due to the word alignment requirements of some machines, they are 
 * stored by order of the decreasing element size: 
 * double, float long, int, short, char rather than the logical order.
 * The details of the storage in the buffer are kept in the 
 * #ObitTableIDI_ARRAY_GEOMETRYDesc.
 *
 * In addition to the normal tabular data, a table will have a "_status"
 * column to indicate the status of each row.
 *
 * \section ObitTableIDI_ARRAY_GEOMETRYSpecification Specifying desired data transfer parameters
 * The desired data transfers are specified in the member ObitInfoList.
 * In the following an ObitInfoList entry is defined by 
 * the name in double quotes, the data type code as an #ObitInfoType enum 
 * and the dimensions of the array (? => depends on application).
 *
 * The following apply to both types of files:
 * \li "nRowPIO", OBIT_int, Max. Number of visibilities per 
 *     "Read" or "Write" operation.  Default = 1.
 *
 * \subsection TableFITS FITS files
 * This implementation uses cfitsio which allows using, in addition to 
 * regular FITS images, gzip compressed files, pipes, shared memory 
 * and a number of other input forms.
 * The convenience Macro #ObitTableIDI_ARRAY_GEOMETRYSetFITS simplifies specifying the 
 * desired data.
 * Binary tables are used for storing visibility data in FITS.
 * For accessing FITS files the following entries in the ObitInfoList 
 * are used:
 * \li "FileName" OBIT_string (?,1,1) FITS file name.
 * \li "TabName"  OBIT_string (?,1,1) Table name (e.g. "AIPS CC").
 * \li "Ver"      OBIT_int    (1,1,1) Table version number
 *
 *
 * \section ObitTableIDI_ARRAY_GEOMETRYaccess Creators and Destructors
 * An ObitTableIDI_ARRAY_GEOMETRY can be created using newObitTableIDI_ARRAY_GEOMETRYValue which attaches the 
 * table to an ObitData for the object.  
 * If the output ObitTableIDI_ARRAY_GEOMETRY has previously been specified, including file information,
 * then ObitTableIDI_ARRAY_GEOMETRYCopy will copy the disk resident as well as the memory 
 * resident information.
 *
 * A copy of a pointer to an ObitTableIDI_ARRAY_GEOMETRY should always be made using the
 * ObitTableIDI_ARRAY_GEOMETRYRef function which updates the reference count in the object.
 * Then whenever freeing an ObitTableIDI_ARRAY_GEOMETRY or changing a pointer, the function
 * ObitTableIDI_ARRAY_GEOMETRYUnref will decrement the reference count and destroy the object
 * when the reference count hits 0.
 *
 * \section ObitTableIDI_ARRAY_GEOMETRYUsage I/O
 * Visibility data is available after an input object is "Opened"
 * and "Read".
 * I/O optionally uses a buffer attached to the ObitTableIDI_ARRAY_GEOMETRY or some external
 * location.
 * To Write an ObitTableIDI_ARRAY_GEOMETRY, create it, open it, and write.
 * The object should be closed to ensure all data is flushed to disk.
 * Deletion of an ObitTableIDI_ARRAY_GEOMETRY after its final unreferencing will automatically
 * close it.
 */

/*--------------Class definitions-------------------------------------*/

/** Number of characters for Table keyword */
 #define MAXKEYCHARTABLEIDI_ARRAY_GEOMETRY 24

/** ObitTableIDI_ARRAY_GEOMETRY Class structure. */
typedef struct {
#include "ObitTableIDI_ARRAY_GEOMETRYDef.h"   /* this class definition */
} ObitTableIDI_ARRAY_GEOMETRY;

/** ObitTableIDI_ARRAY_GEOMETRYRow Class structure. */
typedef struct {
#include "ObitTableIDI_ARRAY_GEOMETRYRowDef.h"   /* this class row definition */
} ObitTableIDI_ARRAY_GEOMETRYRow;

/*----------------- Macroes ---------------------------*/
/** 
 * Macro to unreference (and possibly destroy) an ObitTableIDI_ARRAY_GEOMETRY
 * returns an ObitTableIDI_ARRAY_GEOMETRY*.
 * in = object to unreference
 */
#define ObitTableIDI_ARRAY_GEOMETRYUnref(in) ObitUnref (in)

/** 
 * Macro to reference (update reference count) an ObitTableIDI_ARRAY_GEOMETRY.
 * returns an ObitTableIDI_ARRAY_GEOMETRY*.
 * in = object to reference
 */
#define ObitTableIDI_ARRAY_GEOMETRYRef(in) ObitRef (in)

/** 
 * Macro to determine if an object is the member of this or a 
 * derived class.
 * Returns TRUE if a member, else FALSE
 * in = object to reference
 */
#define ObitTableIDI_ARRAY_GEOMETRYIsA(in) ObitIsA (in, ObitTableIDI_ARRAY_GEOMETRYGetClass())

/** 
 * Macro to unreference (and possibly destroy) an ObitTableIDI_ARRAY_GEOMETRYRow
 * returns an ObitTableIDI_ARRAY_GEOMETRYRow*.
 * in = object to unreference
 */
#define ObitTableIDI_ARRAY_GEOMETRYRowUnref(in) ObitUnref (in)

/** 
 * Macro to reference (update reference count) an ObitTableIDI_ARRAY_GEOMETRYRow.
 * returns an ObitTableIDI_ARRAY_GEOMETRYRow*.
 * in = object to reference
 */
#define ObitTableIDI_ARRAY_GEOMETRYRowRef(in) ObitRef (in)

/** 
 * Macro to determine if an object is the member of this or a 
 * derived class.
 * Returns TRUE if a member, else FALSE
 * in = object to reference
 */
#define ObitTableIDI_ARRAY_GEOMETRYRowIsA(in) ObitIsA (in, ObitTableIDI_ARRAY_GEOMETRYRowGetClass())

/*---------------Public functions---------------------------*/
/*----------------Table Row Functions ----------------------*/
/** Public: Row Class initializer. */
void ObitTableIDI_ARRAY_GEOMETRYRowClassInit (void);

/** Public: Constructor. */
ObitTableIDI_ARRAY_GEOMETRYRow* newObitTableIDI_ARRAY_GEOMETRYRow (ObitTableIDI_ARRAY_GEOMETRY *table);

/** Public: ClassInfo pointer */
gconstpointer ObitTableIDI_ARRAY_GEOMETRYRowGetClass (void);

/*------------------Table Functions ------------------------*/
/** Public: Class initializer. */
void ObitTableIDI_ARRAY_GEOMETRYClassInit (void);

/** Public: Constructor. */
ObitTableIDI_ARRAY_GEOMETRY* newObitTableIDI_ARRAY_GEOMETRY (gchar* name);

/** Public: Constructor from values. */
ObitTableIDI_ARRAY_GEOMETRY* 
newObitTableIDI_ARRAY_GEOMETRYValue (gchar* name, ObitData *file, olong *ver,
  		     ObitIOAccess access,
                     oint no_band, oint numOrb,
		     ObitErr *err);

/** Public: Class initializer. */
void ObitTableIDI_ARRAY_GEOMETRYClassInit (void);

/** Public: ClassInfo pointer */
gconstpointer ObitTableIDI_ARRAY_GEOMETRYGetClass (void);

/** Public: Copy (deep) constructor. */
ObitTableIDI_ARRAY_GEOMETRY* ObitTableIDI_ARRAY_GEOMETRYCopy  (ObitTableIDI_ARRAY_GEOMETRY *in, ObitTableIDI_ARRAY_GEOMETRY *out, 
			   ObitErr *err);

/** Public: Copy (shallow) constructor. */
ObitTableIDI_ARRAY_GEOMETRY* ObitTableIDI_ARRAY_GEOMETRYClone (ObitTableIDI_ARRAY_GEOMETRY *in, ObitTableIDI_ARRAY_GEOMETRY *out);

/** Public: Convert an ObitTable to an ObitTableIDI_ARRAY_GEOMETRY */
ObitTableIDI_ARRAY_GEOMETRY* ObitTableIDI_ARRAY_GEOMETRYConvert  (ObitTable *in);

/** Public: Create ObitIO structures and open file */
ObitIOCode ObitTableIDI_ARRAY_GEOMETRYOpen (ObitTableIDI_ARRAY_GEOMETRY *in, ObitIOAccess access, 
			  ObitErr *err);

/** Public: Read a table row */
ObitIOCode 
ObitTableIDI_ARRAY_GEOMETRYReadRow  (ObitTableIDI_ARRAY_GEOMETRY *in, olong iIDI_ARRAY_GEOMETRYRow, ObitTableIDI_ARRAY_GEOMETRYRow *row,
		     ObitErr *err);

/** Public: Init a table row for write */
void 
ObitTableIDI_ARRAY_GEOMETRYSetRow  (ObitTableIDI_ARRAY_GEOMETRY *in, ObitTableIDI_ARRAY_GEOMETRYRow *row,
		     ObitErr *err);

/** Public: Write a table row */
ObitIOCode 
ObitTableIDI_ARRAY_GEOMETRYWriteRow  (ObitTableIDI_ARRAY_GEOMETRY *in, olong iIDI_ARRAY_GEOMETRYRow, ObitTableIDI_ARRAY_GEOMETRYRow *row,
		     ObitErr *err);

/** Public: Close file and become inactive */
ObitIOCode ObitTableIDI_ARRAY_GEOMETRYClose (ObitTableIDI_ARRAY_GEOMETRY *in, ObitErr *err);

/*----------- ClassInfo Structure -----------------------------------*/
/**
 * ClassInfo Structure.
 * Contains class name, a pointer to any parent class
 * (NULL if none) and function pointers.
 */
typedef struct  {
#include "ObitTableIDI_ARRAY_GEOMETRYClassDef.h"
} ObitTableIDI_ARRAY_GEOMETRYClassInfo; 

/**
 * ClassInfo Structure For TableIDI_ARRAY_GEOMETRYRow.
 * Contains class name, a pointer to any parent class
 * (NULL if none) and function pointers.
 */
typedef struct  {
#include "ObitTableIDI_ARRAY_GEOMETRYRowClassDef.h"
} ObitTableIDI_ARRAY_GEOMETRYRowClassInfo; 
#endif /* OBITTABLEIDI_ARRAY_GEOMETRY_H */ 
