/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#ifndef OBITTABLEIDI_GAIN_CURVE_H 
#define OBITTABLEIDI_GAIN_CURVE_H 

#include "Obit.h"
#include "ObitErr.h"
#include "ObitTable.h"
#include "ObitData.h"

/*-------- Obit: Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_GAIN_CURVE.h
 * ObitTableIDI_GAIN_CURVE class definition.
 *
 * This class is derived from the #ObitTable class.
 *
 * This class contains tabular data and allows access.
 * This table is part of the IDI uv data format.
 * "IDI\_GAIN\_CURVE" contains antenna gain as a function of pointing position.
 * An ObitTableIDI\_GAIN\_CURVE is the front end to a persistent disk resident structure.
 * Only FITS cataloged data are supported.
 * This class is derived from the ObitTable class.
 *
 * This class contains tabular data and allows access.
 * "IDI_GAIN_CURVE" table
 * An ObitTableIDI_GAIN_CURVE is the front end to a persistent disk resident structure.
 * Only FITS (as Tables) are supported.
 *
 * \section TableDataStorage Table data storage
 * In memory tables are stored in a fashion similar to how they are 
 * stored on disk - in large blocks in memory rather than structures.
 * Due to the word alignment requirements of some machines, they are 
 * stored by order of the decreasing element size: 
 * double, float long, int, short, char rather than the logical order.
 * The details of the storage in the buffer are kept in the 
 * #ObitTableIDI_GAIN_CURVEDesc.
 *
 * In addition to the normal tabular data, a table will have a "_status"
 * column to indicate the status of each row.
 *
 * \section ObitTableIDI_GAIN_CURVESpecification Specifying desired data transfer parameters
 * The desired data transfers are specified in the member ObitInfoList.
 * In the following an ObitInfoList entry is defined by 
 * the name in double quotes, the data type code as an #ObitInfoType enum 
 * and the dimensions of the array (? => depends on application).
 *
 * The following apply to both types of files:
 * \li "nRowPIO", OBIT_int, Max. Number of visibilities per 
 *     "Read" or "Write" operation.  Default = 1.
 *
 * \subsection TableFITS FITS files
 * This implementation uses cfitsio which allows using, in addition to 
 * regular FITS images, gzip compressed files, pipes, shared memory 
 * and a number of other input forms.
 * The convenience Macro #ObitTableIDI_GAIN_CURVESetFITS simplifies specifying the 
 * desired data.
 * Binary tables are used for storing visibility data in FITS.
 * For accessing FITS files the following entries in the ObitInfoList 
 * are used:
 * \li "FileName" OBIT_string (?,1,1) FITS file name.
 * \li "TabName"  OBIT_string (?,1,1) Table name (e.g. "AIPS CC").
 * \li "Ver"      OBIT_int    (1,1,1) Table version number
 *
 *
 * \section ObitTableIDI_GAIN_CURVEaccess Creators and Destructors
 * An ObitTableIDI_GAIN_CURVE can be created using newObitTableIDI_GAIN_CURVEValue which attaches the 
 * table to an ObitData for the object.  
 * If the output ObitTableIDI_GAIN_CURVE has previously been specified, including file information,
 * then ObitTableIDI_GAIN_CURVECopy will copy the disk resident as well as the memory 
 * resident information.
 *
 * A copy of a pointer to an ObitTableIDI_GAIN_CURVE should always be made using the
 * ObitTableIDI_GAIN_CURVERef function which updates the reference count in the object.
 * Then whenever freeing an ObitTableIDI_GAIN_CURVE or changing a pointer, the function
 * ObitTableIDI_GAIN_CURVEUnref will decrement the reference count and destroy the object
 * when the reference count hits 0.
 *
 * \section ObitTableIDI_GAIN_CURVEUsage I/O
 * Visibility data is available after an input object is "Opened"
 * and "Read".
 * I/O optionally uses a buffer attached to the ObitTableIDI_GAIN_CURVE or some external
 * location.
 * To Write an ObitTableIDI_GAIN_CURVE, create it, open it, and write.
 * The object should be closed to ensure all data is flushed to disk.
 * Deletion of an ObitTableIDI_GAIN_CURVE after its final unreferencing will automatically
 * close it.
 */

/*--------------Class definitions-------------------------------------*/

/** Number of characters for Table keyword */
 #define MAXKEYCHARTABLEIDI_GAIN_CURVE 24

/** ObitTableIDI_GAIN_CURVE Class structure. */
typedef struct {
#include "ObitTableIDI_GAIN_CURVEDef.h"   /* this class definition */
} ObitTableIDI_GAIN_CURVE;

/** ObitTableIDI_GAIN_CURVERow Class structure. */
typedef struct {
#include "ObitTableIDI_GAIN_CURVERowDef.h"   /* this class row definition */
} ObitTableIDI_GAIN_CURVERow;

/*----------------- Macroes ---------------------------*/
/** 
 * Macro to unreference (and possibly destroy) an ObitTableIDI_GAIN_CURVE
 * returns an ObitTableIDI_GAIN_CURVE*.
 * in = object to unreference
 */
#define ObitTableIDI_GAIN_CURVEUnref(in) ObitUnref (in)

/** 
 * Macro to reference (update reference count) an ObitTableIDI_GAIN_CURVE.
 * returns an ObitTableIDI_GAIN_CURVE*.
 * in = object to reference
 */
#define ObitTableIDI_GAIN_CURVERef(in) ObitRef (in)

/** 
 * Macro to determine if an object is the member of this or a 
 * derived class.
 * Returns TRUE if a member, else FALSE
 * in = object to reference
 */
#define ObitTableIDI_GAIN_CURVEIsA(in) ObitIsA (in, ObitTableIDI_GAIN_CURVEGetClass())

/** 
 * Macro to unreference (and possibly destroy) an ObitTableIDI_GAIN_CURVERow
 * returns an ObitTableIDI_GAIN_CURVERow*.
 * in = object to unreference
 */
#define ObitTableIDI_GAIN_CURVERowUnref(in) ObitUnref (in)

/** 
 * Macro to reference (update reference count) an ObitTableIDI_GAIN_CURVERow.
 * returns an ObitTableIDI_GAIN_CURVERow*.
 * in = object to reference
 */
#define ObitTableIDI_GAIN_CURVERowRef(in) ObitRef (in)

/** 
 * Macro to determine if an object is the member of this or a 
 * derived class.
 * Returns TRUE if a member, else FALSE
 * in = object to reference
 */
#define ObitTableIDI_GAIN_CURVERowIsA(in) ObitIsA (in, ObitTableIDI_GAIN_CURVERowGetClass())

/*---------------Public functions---------------------------*/
/*----------------Table Row Functions ----------------------*/
/** Public: Row Class initializer. */
void ObitTableIDI_GAIN_CURVERowClassInit (void);

/** Public: Constructor. */
ObitTableIDI_GAIN_CURVERow* newObitTableIDI_GAIN_CURVERow (ObitTableIDI_GAIN_CURVE *table);

/** Public: ClassInfo pointer */
gconstpointer ObitTableIDI_GAIN_CURVERowGetClass (void);

/*------------------Table Functions ------------------------*/
/** Public: Class initializer. */
void ObitTableIDI_GAIN_CURVEClassInit (void);

/** Public: Constructor. */
ObitTableIDI_GAIN_CURVE* newObitTableIDI_GAIN_CURVE (gchar* name);

/** Public: Constructor from values. */
ObitTableIDI_GAIN_CURVE* 
newObitTableIDI_GAIN_CURVEValue (gchar* name, ObitData *file, olong *ver,
  		     ObitIOAccess access,
                     oint numPol, oint no_band, oint numTabs,
		     ObitErr *err);

/** Public: Class initializer. */
void ObitTableIDI_GAIN_CURVEClassInit (void);

/** Public: ClassInfo pointer */
gconstpointer ObitTableIDI_GAIN_CURVEGetClass (void);

/** Public: Copy (deep) constructor. */
ObitTableIDI_GAIN_CURVE* ObitTableIDI_GAIN_CURVECopy  (ObitTableIDI_GAIN_CURVE *in, ObitTableIDI_GAIN_CURVE *out, 
			   ObitErr *err);

/** Public: Copy (shallow) constructor. */
ObitTableIDI_GAIN_CURVE* ObitTableIDI_GAIN_CURVEClone (ObitTableIDI_GAIN_CURVE *in, ObitTableIDI_GAIN_CURVE *out);

/** Public: Convert an ObitTable to an ObitTableIDI_GAIN_CURVE */
ObitTableIDI_GAIN_CURVE* ObitTableIDI_GAIN_CURVEConvert  (ObitTable *in);

/** Public: Create ObitIO structures and open file */
ObitIOCode ObitTableIDI_GAIN_CURVEOpen (ObitTableIDI_GAIN_CURVE *in, ObitIOAccess access, 
			  ObitErr *err);

/** Public: Read a table row */
ObitIOCode 
ObitTableIDI_GAIN_CURVEReadRow  (ObitTableIDI_GAIN_CURVE *in, olong iIDI_GAIN_CURVERow, ObitTableIDI_GAIN_CURVERow *row,
		     ObitErr *err);

/** Public: Init a table row for write */
void 
ObitTableIDI_GAIN_CURVESetRow  (ObitTableIDI_GAIN_CURVE *in, ObitTableIDI_GAIN_CURVERow *row,
		     ObitErr *err);

/** Public: Write a table row */
ObitIOCode 
ObitTableIDI_GAIN_CURVEWriteRow  (ObitTableIDI_GAIN_CURVE *in, olong iIDI_GAIN_CURVERow, ObitTableIDI_GAIN_CURVERow *row,
		     ObitErr *err);

/** Public: Close file and become inactive */
ObitIOCode ObitTableIDI_GAIN_CURVEClose (ObitTableIDI_GAIN_CURVE *in, ObitErr *err);

/*----------- ClassInfo Structure -----------------------------------*/
/**
 * ClassInfo Structure.
 * Contains class name, a pointer to any parent class
 * (NULL if none) and function pointers.
 */
typedef struct  {
#include "ObitTableIDI_GAIN_CURVEClassDef.h"
} ObitTableIDI_GAIN_CURVEClassInfo; 

/**
 * ClassInfo Structure For TableIDI_GAIN_CURVERow.
 * Contains class name, a pointer to any parent class
 * (NULL if none) and function pointers.
 */
typedef struct  {
#include "ObitTableIDI_GAIN_CURVERowClassDef.h"
} ObitTableIDI_GAIN_CURVERowClassInfo; 
#endif /* OBITTABLEIDI_GAIN_CURVE_H */ 
