/* $Id: ObitTableAN.c 128 2009-09-23 14:48:29Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableAN.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableAN.c
 * ObitTableAN class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableAN";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableANRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableANRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableANClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableANClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableANRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableANRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableANInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableANClear (gpointer in);

/** Private: update table specific info */
static void ObitTableANUpdate (ObitTableAN *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableANDumpKey (ObitTableAN *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableANClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableANRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableANRow* newObitTableANRow (ObitTableAN *table)
{
  ObitTableANRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableANRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableANRow));

  /* initialize values */
  out->name = g_strdup("TableAN Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableANRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->AntName = cRow + table->AntNameOff;
    out->StaXYZ = dRow + table->StaXYZOff;
    out->OrbParm = dRow + table->OrbParmOff;
    out->polTypeA = cRow + table->polTypeAOff;
    out->PolCalA = fRow + table->PolCalAOff;
    out->polTypeB = cRow + table->polTypeBOff;
    out->PolCalB = fRow + table->PolCalBOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableANRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableANRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableANRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableANRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableAN* newObitTableAN (gchar* name)
{
  ObitTableAN* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableANClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableAN));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableANInit((gpointer)out);

 return out;
} /* end newObitTableAN */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableANGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableANClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitANGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numOrb Number of orbital parameters
 * \param numPCal Number of polarization calibration constants
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableAN* newObitTableANValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numOrb, oint numPCal,
		     ObitErr *err)
{
  ObitTableAN* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS AN";
  gchar *routine = "newObitTableANValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableANClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS AN");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableAN */
      if (ObitTableANIsA(testTab)) { /* it is an ObitTableAN */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableANConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS AN");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableANIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableANConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numOrb = MAX (0, numOrb);
  out->numPCal = MAX (0, numPCal);
  out->ArrayX = 0.0;
  out->ArrayY = 0.0;
  out->ArrayZ = 0.0;
  out->GSTiat0 = 0.0;
  out->DegDay = 360.0;
  out->Freq = 1.0;
  strncpy (out->RefDate, "YYYYMMDD", MAXKEYCHARTABLEAN );
  out->PolarX = 0.0;
  out->PolarY = 0.0;
  out->dataUtc = 0.0;
  strncpy (out->TimeSys, "IAT", MAXKEYCHARTABLEAN );
  out->FreqID = 0;
  out->iatUtc = 0.0;
  strncpy (out->polType, "        ", MAXKEYCHARTABLEAN );
  out->P_Refant = 0;
  out->P_Diff01 = 0.0;
  out->P_Diff02 = 0.0;
  out->P_Diff03 = 0.0;
  out->P_Diff04 = 0.0;
  out->P_Diff05 = 0.0;
  out->P_Diff06 = 0.0;
  out->P_Diff07 = 0.0;
  out->P_Diff08 = 0.0;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 12 + out->numOrb*0 + out->numPCal*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  optional = FALSE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("ANNAME  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    colNo++;
  }
  optional = FALSE;
  if ((3 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("STABXYZ ");
    desc->FieldUnit[colNo] = g_strdup("METERS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 3;
    colNo++;
  }
  optional = FALSE;
  if ((numOrb > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("ORBPARM ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numOrb;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("NOSTA   ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("MNTSTA  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("STAXOF  ");
  desc->FieldUnit[colNo] = g_strdup("METERS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((4 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLTYA  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 4;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("POLAA   ");
  desc->FieldUnit[colNo] = g_strdup("DEGREES");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((numPCal > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLCALA");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numPCal;
    colNo++;
  }
  optional = FALSE;
  if ((4 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLTYB ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 4;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("POLAB  ");
  desc->FieldUnit[colNo] = g_strdup("DEGREES");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((numPCal > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLCALB");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numPCal;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableANDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableANOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableANClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableANValue */

/**
 * Convert an ObitTable to an ObitTableAN.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableAN* ObitTableANConvert (ObitTable* in)
{
  ObitTableAN *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableAN(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableANConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableAN* ObitTableANCopy (ObitTableAN *in, ObitTableAN *out, ObitErr *err)
{
  gchar *routine = "ObitTableANCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableANClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableAN*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->ArrayX = in->ArrayX;
  out->ArrayY = in->ArrayY;
  out->ArrayZ = in->ArrayZ;
  out->GSTiat0 = in->GSTiat0;
  out->DegDay = in->DegDay;
  out->Freq = in->Freq;
  strncpy (out->RefDate, in->RefDate, MAXKEYCHARTABLEAN );
  out->PolarX = in->PolarX;
  out->PolarY = in->PolarY;
  out->ut1Utc = in->ut1Utc;
  out->dataUtc = in->dataUtc;
  strncpy (out->TimeSys, in->TimeSys, MAXKEYCHARTABLEAN );
  strncpy (out->ArrName, in->ArrName, MAXKEYCHARTABLEAN );
  out->numOrb = in->numOrb;
  out->numPCal = in->numPCal;
  out->FreqID = in->FreqID;
  out->iatUtc = in->iatUtc;
  strncpy (out->polType, in->polType, MAXKEYCHARTABLEAN );
  out->P_Refant = in->P_Refant;
  out->P_Diff01 = in->P_Diff01;
  out->P_Diff02 = in->P_Diff02;
  out->P_Diff03 = in->P_Diff03;
  out->P_Diff04 = in->P_Diff04;
  out->P_Diff05 = in->P_Diff05;
  out->P_Diff06 = in->P_Diff06;
  out->P_Diff07 = in->P_Diff07;
  out->P_Diff08 = in->P_Diff08;
  /* Update class specific info */
  ObitTableANUpdate (out, err);
    
  return out;
} /* end ObitTableANCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableANOpen (ObitTableAN *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableANOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableANClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableANUpdate (in, err);
   
   return retCode;
} /* end ObitTableANOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iANRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableANReadRow  (ObitTableAN *in, olong iANRow, ObitTableANRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableANReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS AN Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iANRow */
  retCode = ObitTableRead ((ObitTable*)in, iANRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->noSta = iRow[in->noStaOff];
  row->mntSta = iRow[in->mntStaOff];
  row->staXof = fRow[in->staXofOff];
  row->PolAngA = fRow[in->PolAngAOff];
  row->PolAngB = fRow[in->PolAngBOff];
  row->AntName = cRow + in->AntNameOff;
  row->StaXYZ = dRow + in->StaXYZOff;
  row->OrbParm = dRow + in->OrbParmOff;
  row->polTypeA = cRow + in->polTypeAOff;
  row->PolCalA = fRow + in->PolCalAOff;
  row->polTypeB = cRow + in->polTypeBOff;
  row->PolCalB = fRow + in->PolCalBOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableANReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableANSetRow  (ObitTableAN *in, ObitTableANRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AN Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->AntName = cRow + in->AntNameOff;
  row->StaXYZ = dRow + in->StaXYZOff;
  row->OrbParm = dRow + in->OrbParmOff;
  row->polTypeA = cRow + in->polTypeAOff;
  row->PolCalA = fRow + in->PolCalAOff;
  row->polTypeB = cRow + in->polTypeBOff;
  row->PolCalB = fRow + in->PolCalBOff;

} /*  end ObitTableANSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableANSetRow  
 * \param in       Table to read
 * \param iANRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableANWriteRow  (ObitTableAN *in, olong iANRow, ObitTableANRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableANWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS AN Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  iRow[in->noStaOff] = row->noSta;
  iRow[in->mntStaOff] = row->mntSta;
  fRow[in->staXofOff] = row->staXof;
  fRow[in->PolAngAOff] = row->PolAngA;
  fRow[in->PolAngBOff] = row->PolAngB;
  if (in->AntNameCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->AntNameCol]; i++) 
      cRow[in->AntNameOff+i] = row->AntName[i];
  } 
  if (in->StaXYZCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->StaXYZCol]; i++) 
      dRow[in->StaXYZOff+i] = row->StaXYZ[i];
  } 
  if (in->OrbParmCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->OrbParmCol]; i++) 
      dRow[in->OrbParmOff+i] = row->OrbParm[i];
  } 
  if (in->polTypeACol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->polTypeACol]; i++) 
      cRow[in->polTypeAOff+i] = row->polTypeA[i];
  } 
  if (in->PolCalACol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PolCalACol]; i++) 
      fRow[in->PolCalAOff+i] = row->PolCalA[i];
  } 
  if (in->polTypeBCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->polTypeBCol]; i++) 
      cRow[in->polTypeBOff+i] = row->polTypeB[i];
  } 
  if (in->PolCalBCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PolCalBCol]; i++) 
      fRow[in->PolCalBOff+i] = row->PolCalB[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iANRow */
  retCode = ObitTableWrite ((ObitTable*)in, iANRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableANWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableANClose (ObitTableAN *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableANClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableANDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableANClose */

/*---------------Private functions--------------------------*/
/*----------------  TableAN Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableANRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableANRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->AntName = NULL;
  in->StaXYZ = NULL;
  in->OrbParm = NULL;
  in->polTypeA = NULL;
  in->PolCalA = NULL;
  in->polTypeB = NULL;
  in->PolCalB = NULL;

} /* end ObitTableANRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableANRow* cast to an Obit*.
 */
void ObitTableANRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableANRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableANRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableANRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableANRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableANRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableANRowClassInfoDefFn (gpointer inClass)
{
  ObitTableANRowClassInfo *theClass = (ObitTableANRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableANRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableANRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableANRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableANRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableANRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableANRowInit;

} /* end ObitTableANRowClassDefFn */

/*------------------  TableAN  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableANInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableAN *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableANInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableAN* cast to an Obit*.
 */
void ObitTableANClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableAN *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableANClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableANClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableANClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableANClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableANClassInfoDefFn (gpointer inClass)
{
  ObitTableANClassInfo *theClass = (ObitTableANClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableANClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableANClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableANGetClass;
  theClass->newObit       = (newObitFP)newObitTableAN;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableANCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableANClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableANInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableANConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableANOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableANClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableANReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableANWriteRow;

} /* end ObitTableANClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableANUpdate (ObitTableAN *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
  in->ArrayX = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "ARRAYX", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->ArrayX = InfoReal.dbl;
  if (type==OBIT_float)  in->ArrayX = InfoReal.flt;
  in->ArrayY = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "ARRAYY", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->ArrayY = InfoReal.dbl;
  if (type==OBIT_float)  in->ArrayY = InfoReal.flt;
  in->ArrayZ = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "ARRAYZ", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->ArrayZ = InfoReal.dbl;
  if (type==OBIT_float)  in->ArrayZ = InfoReal.flt;
  in->GSTiat0 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "GSTIA0", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->GSTiat0 = InfoReal.dbl;
  if (type==OBIT_float)  in->GSTiat0 = InfoReal.flt;
  in->DegDay = 360.0; 
  InfoReal.dbl = 360.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "DEGPDY", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->DegDay = InfoReal.dbl;
  if (type==OBIT_float)  in->DegDay = InfoReal.flt;
  in->Freq = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "FREQ", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->Freq = InfoReal.dbl;
  if (type==OBIT_float)  in->Freq = InfoReal.flt;
   /* RefDate */
  strncpy (in->RefDate, "YYYYMMDD", MAXKEYCHARTABLEAN); 
  ObitInfoListGetTest(in->myDesc->info, "RDATE", &type, dim, 
		       (gpointer)&in->RefDate);
  in->PolarX = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "POLARX", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->PolarX = InfoReal.dbl;
  if (type==OBIT_float)  in->PolarX = InfoReal.flt;
  in->PolarY = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "POLARY", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->PolarY = InfoReal.dbl;
  if (type==OBIT_float)  in->PolarY = InfoReal.flt;
   /* ut1Utc */
  if (!ObitInfoListGet(in->myDesc->info, "UT1UTC", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->ut1Utc = InfoReal.dbl;
  if (type==OBIT_float)  in->ut1Utc = InfoReal.flt;
  in->dataUtc = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "DATUTC", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->dataUtc = InfoReal.dbl;
  if (type==OBIT_float)  in->dataUtc = InfoReal.flt;
   /* TimeSys */
  strncpy (in->TimeSys, "IAT", MAXKEYCHARTABLEAN); 
  ObitInfoListGetTest(in->myDesc->info, "TIMSYS", &type, dim, 
		       (gpointer)&in->TimeSys);
   /* ArrName */
  if (!ObitInfoListGet(in->myDesc->info, "ARRNAM", &type, dim, 
		       (gpointer)&in->ArrName, err)) return;
   /* numOrb */
  in->numOrb = 0; 
  ObitInfoListGetTest(in->myDesc->info, "NUMORB", &type, dim, 
		       (gpointer)&in->numOrb);
   /* numPCal */
  in->numPCal = 4; 
  ObitInfoListGetTest(in->myDesc->info, "NOPCAL", &type, dim, 
		       (gpointer)&in->numPCal);
   /* FreqID */
  in->FreqID = 0; 
  ObitInfoListGetTest(in->myDesc->info, "FREQID", &type, dim, 
		       (gpointer)&in->FreqID);
  in->iatUtc = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "IATUTC", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->iatUtc = InfoReal.dbl;
  if (type==OBIT_float)  in->iatUtc = InfoReal.flt;
   /* polType */
  strncpy (in->polType, "        ", MAXKEYCHARTABLEAN); 
  ObitInfoListGetTest(in->myDesc->info, "POLTYPE", &type, dim, 
		       (gpointer)&in->polType);
   /* P_Refant */
  in->P_Refant = 0; 
  ObitInfoListGetTest(in->myDesc->info, "P_REFANT", &type, dim, 
		       (gpointer)&in->P_Refant);
  in->P_Diff01 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "P_DIFF01", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->P_Diff01 = InfoReal.dbl;
  if (type==OBIT_float)  in->P_Diff01 = InfoReal.flt;
  in->P_Diff02 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "P_DIFF02", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->P_Diff02 = InfoReal.dbl;
  if (type==OBIT_float)  in->P_Diff02 = InfoReal.flt;
  in->P_Diff03 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "P_DIFF03", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->P_Diff03 = InfoReal.dbl;
  if (type==OBIT_float)  in->P_Diff03 = InfoReal.flt;
  in->P_Diff04 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "P_DIFF04", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->P_Diff04 = InfoReal.dbl;
  if (type==OBIT_float)  in->P_Diff04 = InfoReal.flt;
  in->P_Diff05 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "P_DIFF05", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->P_Diff05 = InfoReal.dbl;
  if (type==OBIT_float)  in->P_Diff05 = InfoReal.flt;
  in->P_Diff06 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "P_DIFF06", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->P_Diff06 = InfoReal.dbl;
  if (type==OBIT_float)  in->P_Diff06 = InfoReal.flt;
  in->P_Diff07 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "P_DIFF07", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->P_Diff07 = InfoReal.dbl;
  if (type==OBIT_float)  in->P_Diff07 = InfoReal.flt;
  in->P_Diff08 = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "P_DIFF08", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->P_Diff08 = InfoReal.dbl;
  if (type==OBIT_float)  in->P_Diff08 = InfoReal.flt;

  /* initialize column numbers/offsets */
  in->AntNameOff = -1;
  in->AntNameCol = -1;
  in->StaXYZOff = -1;
  in->StaXYZCol = -1;
  in->OrbParmOff = -1;
  in->OrbParmCol = -1;
  in->noStaOff = -1;
  in->noStaCol = -1;
  in->mntStaOff = -1;
  in->mntStaCol = -1;
  in->staXofOff = -1;
  in->staXofCol = -1;
  in->polTypeAOff = -1;
  in->polTypeACol = -1;
  in->PolAngAOff = -1;
  in->PolAngACol = -1;
  in->PolCalAOff = -1;
  in->PolCalACol = -1;
  in->polTypeBOff = -1;
  in->polTypeBCol = -1;
  in->PolAngBOff = -1;
  in->PolAngBCol = -1;
  in->PolCalBOff = -1;
  in->PolCalBCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "ANNAME  ", 8)) {
	 in->AntNameOff = desc->offset[i];
 	 in->AntNameCol = i;
      }
      if (!strncmp (desc->FieldName[i], "STABXYZ ", 8)) {
	 in->StaXYZOff = desc->offset[i];
 	 in->StaXYZCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ORBPARM ", 8)) {
	 in->OrbParmOff = desc->offset[i];
 	 in->OrbParmCol = i;
      }
      if (!strncmp (desc->FieldName[i], "NOSTA   ", 8)) {
	 in->noStaOff = desc->offset[i];
 	 in->noStaCol = i;
      }
      if (!strncmp (desc->FieldName[i], "MNTSTA  ", 8)) {
	 in->mntStaOff = desc->offset[i];
 	 in->mntStaCol = i;
      }
      if (!strncmp (desc->FieldName[i], "STAXOF  ", 8)) {
	 in->staXofOff = desc->offset[i];
 	 in->staXofCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLTYA  ", 8)) {
	 in->polTypeAOff = desc->offset[i];
 	 in->polTypeACol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLAA   ", 8)) {
	 in->PolAngAOff = desc->offset[i];
 	 in->PolAngACol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLCALA", 7)) {
	 in->PolCalAOff = desc->offset[i];
 	 in->PolCalACol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLTYB ", 7)) {
	 in->polTypeBOff = desc->offset[i];
 	 in->polTypeBCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLAB  ", 7)) {
	 in->PolAngBOff = desc->offset[i];
 	 in->PolAngBCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLCALB", 7)) {
	 in->PolCalBOff = desc->offset[i];
 	 in->PolCalBCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->AntNameOff > -1), err,
       "ObitTableANUpdate: Could not find column AntName");
  Obit_return_if_fail((in->StaXYZOff > -1), err,
       "ObitTableANUpdate: Could not find column StaXYZ");
  Obit_return_if_fail((in->OrbParmOff > -1), err,
       "ObitTableANUpdate: Could not find column OrbParm");
  Obit_return_if_fail((in->noStaOff > -1), err,
       "ObitTableANUpdate: Could not find column noSta");
  Obit_return_if_fail((in->mntStaOff > -1), err,
       "ObitTableANUpdate: Could not find column mntSta");
  Obit_return_if_fail((in->staXofOff > -1), err,
       "ObitTableANUpdate: Could not find column staXof");
  Obit_return_if_fail((in->polTypeAOff > -1), err,
       "ObitTableANUpdate: Could not find column polTypeA");
  Obit_return_if_fail((in->PolAngAOff > -1), err,
       "ObitTableANUpdate: Could not find column PolAngA");
  Obit_return_if_fail((in->PolCalAOff > -1), err,
       "ObitTableANUpdate: Could not find column PolCalA");
  Obit_return_if_fail((in->polTypeBOff > -1), err,
       "ObitTableANUpdate: Could not find column polTypeB");
  Obit_return_if_fail((in->PolAngBOff > -1), err,
       "ObitTableANUpdate: Could not find column PolAngB");
} /* end ObitTableANUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableANDumpKey (ObitTableAN *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
  else info = in->myDesc->info;
  /* ArrayX */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "ARRAYX", type, dim, 
		  (gpointer)&in->ArrayX);
  /* ArrayY */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "ARRAYY", type, dim, 
		  (gpointer)&in->ArrayY);
  /* ArrayZ */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "ARRAYZ", type, dim, 
		  (gpointer)&in->ArrayZ);
  /* GSTiat0 */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "GSTIA0", type, dim, 
		  (gpointer)&in->GSTiat0);
  /* DegDay */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "DEGPDY", type, dim, 
		  (gpointer)&in->DegDay);
  /* Freq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "FREQ", type, dim, 
		  (gpointer)&in->Freq);
  /* RefDate */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEAN;
  ObitInfoListAlwaysPut(info, "RDATE", type, dim, 
		  (gpointer)&in->RefDate);
  /* PolarX */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "POLARX", type, dim, 
		  (gpointer)&in->PolarX);
  /* PolarY */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "POLARY", type, dim, 
		  (gpointer)&in->PolarY);
  /* ut1Utc */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "UT1UTC", type, dim, 
		  (gpointer)&in->ut1Utc);
  /* dataUtc */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "DATUTC", type, dim, 
		  (gpointer)&in->dataUtc);
  /* TimeSys */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEAN;
  ObitInfoListAlwaysPut(info, "TIMSYS", type, dim, 
		  (gpointer)&in->TimeSys);
  /* ArrName */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEAN;
  ObitInfoListAlwaysPut(info, "ARRNAM", type, dim, 
		  (gpointer)&in->ArrName);
  /* numOrb */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NUMORB", type, dim, 
		  (gpointer)&in->numOrb);
  /* numPCal */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NOPCAL", type, dim, 
		  (gpointer)&in->numPCal);
  /* FreqID */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "FREQID", type, dim, 
		  (gpointer)&in->FreqID);
  /* iatUtc */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "IATUTC", type, dim, 
		  (gpointer)&in->iatUtc);
  /* polType */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEAN;
  ObitInfoListAlwaysPut(info, "POLTYPE", type, dim, 
		  (gpointer)&in->polType);
  /* P_Refant */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "P_REFANT", type, dim, 
		  (gpointer)&in->P_Refant);
  /* P_Diff01 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "P_DIFF01", type, dim, 
		  (gpointer)&in->P_Diff01);
  /* P_Diff02 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "P_DIFF02", type, dim, 
		  (gpointer)&in->P_Diff02);
  /* P_Diff03 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "P_DIFF03", type, dim, 
		  (gpointer)&in->P_Diff03);
  /* P_Diff04 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "P_DIFF04", type, dim, 
		  (gpointer)&in->P_Diff04);
  /* P_Diff05 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "P_DIFF05", type, dim, 
		  (gpointer)&in->P_Diff05);
  /* P_Diff06 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "P_DIFF06", type, dim, 
		  (gpointer)&in->P_Diff06);
  /* P_Diff07 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "P_DIFF07", type, dim, 
		  (gpointer)&in->P_Diff07);
  /* P_Diff08 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "P_DIFF08", type, dim, 
		  (gpointer)&in->P_Diff08);
   
} /* end ObitTableANDumpKey */
