/* $Id: ObitTableCL.c 128 2009-09-23 14:48:29Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableCL.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableCL.c
 * ObitTableCL class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableCL";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableCLRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableCLRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableCLClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableCLClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableCLRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableCLRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableCLInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableCLClear (gpointer in);

/** Private: update table specific info */
static void ObitTableCLUpdate (ObitTableCL *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableCLDumpKey (ObitTableCL *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableCLClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableCLRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableCLRow* newObitTableCLRow (ObitTableCL *table)
{
  ObitTableCLRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableCLRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableCLRow));

  /* initialize values */
  out->name = g_strdup("TableCL Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableCLRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->GeoDelay = dRow + table->GeoDelayOff;
    out->DopplerOff = fRow + table->DopplerOffOff;
    if (table->numPol>=1) out->MBDelay1 = fRow[table->MBDelay1Off];
    if (table->numPol>=1) out->clock1 = fRow[table->clock1Off];
    if (table->numPol>=1) out->Dclock1 = fRow[table->Dclock1Off];
    if (table->numPol>=1) out->dispers1 = fRow[table->dispers1Off];
    if (table->numPol>=1) out->Ddispers1 = fRow[table->Ddispers1Off];
    if (table->numPol>=1) out->Real1 = fRow + table->Real1Off;
    if (table->numPol>=1) out->Imag1 = fRow + table->Imag1Off;
    if (table->numPol>=1) out->Rate1 = fRow + table->Rate1Off;
    if (table->numPol>=1) out->Delay1 = fRow + table->Delay1Off;
    if (table->numPol>=1) out->Weight1 = fRow + table->Weight1Off;
    if (table->numPol>=1) out->RefAnt1 = iRow + table->RefAnt1Off;
    if (table->numPol>=2) out->MBDelay2 = fRow[table->MBDelay2Off];
    if (table->numPol>=2) out->clock2 = fRow[table->clock2Off];
    if (table->numPol>=2) out->Dclock2 = fRow[table->Dclock2Off];
    if (table->numPol>=2) out->dispers2 = fRow[table->dispers2Off];
    if (table->numPol>=2) out->Ddispers2 = fRow[table->Ddispers2Off];
    if (table->numPol>=2) out->Real2 = fRow + table->Real2Off;
    if (table->numPol>=2) out->Imag2 = fRow + table->Imag2Off;
    if (table->numPol>=2) out->Rate2 = fRow + table->Rate2Off;
    if (table->numPol>=2) out->Delay2 = fRow + table->Delay2Off;
    if (table->numPol>=2) out->Weight2 = fRow + table->Weight2Off;
    if (table->numPol>=2) out->RefAnt2 = iRow + table->RefAnt2Off;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableCLRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableCLRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableCLRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableCLRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableCL* newObitTableCL (gchar* name)
{
  ObitTableCL* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCLClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableCL));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableCLInit((gpointer)out);

 return out;
} /* end newObitTableCL */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableCLGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCLClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitCLGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numPol The number of polarizations
 * \param numIF The number of IFs
 * \param numTerm The number of terms in model polynomial
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableCL* newObitTableCLValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numPol, oint numIF, oint numTerm,
		     ObitErr *err)
{
  ObitTableCL* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS CL";
  gchar *routine = "newObitTableCLValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCLClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS CL");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableCL */
      if (ObitTableCLIsA(testTab)) { /* it is an ObitTableCL */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableCLConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS CL");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableCLIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableCLConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numPol = MAX (0, numPol);
  out->numIF = MAX (0, numIF);
  out->numTerm = MAX (0, numTerm);
  out->revision = 10;
  out->mGMod = 1.0;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 11 + out->numPol*11 + out->numIF*0 + out->numTerm*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TIME INTERVAL");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCE ID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA NO.");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SUBARRAY");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQ ID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("I.FAR.ROT");
  desc->FieldUnit[colNo] = g_strdup("RAD/M**2");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((numTerm > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("GEODELAY ");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTerm;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("DOPPOFF  ");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("ATMOS  ");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DATMOS  ");
  desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("MBDELAY1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("CLOCK 1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DCLOCK 1");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DISP 1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DDISP 1");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("REAL1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("IMAG1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("RATE 1");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DELAY 1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("WEIGHT 1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("REFANT 1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("MBDELAY2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("CLOCK 2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DCLOCK 2");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DISP 2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DDISP 2");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("REAL2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("IMAG2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("RATE 2");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DELAY 2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("WEIGHT 2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("REFANT 2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableCLDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableCLOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableCLClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableCLValue */

/**
 * Convert an ObitTable to an ObitTableCL.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableCL* ObitTableCLConvert (ObitTable* in)
{
  ObitTableCL *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableCL(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableCLConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableCL* ObitTableCLCopy (ObitTableCL *in, ObitTableCL *out, ObitErr *err)
{
  gchar *routine = "ObitTableCLCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCLClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableCL*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->revision = in->revision;
  out->numPol = in->numPol;
  out->numIF = in->numIF;
  out->numAnt = in->numAnt;
  out->numTerm = in->numTerm;
  out->mGMod = in->mGMod;
  /* Update class specific info */
  ObitTableCLUpdate (out, err);
    
  return out;
} /* end ObitTableCLCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableCLOpen (ObitTableCL *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableCLOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCLClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableCLUpdate (in, err);
   
   return retCode;
} /* end ObitTableCLOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iCLRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableCLReadRow  (ObitTableCL *in, olong iCLRow, ObitTableCLRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableCLReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS CL Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iCLRow */
  retCode = ObitTableRead ((ObitTable*)in, iCLRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->TimeI = fRow[in->TimeIOff];
  row->SourID = iRow[in->SourIDOff];
  row->antNo = iRow[in->antNoOff];
  row->SubA = iRow[in->SubAOff];
  row->FreqID = iRow[in->FreqIDOff];
  row->IFR = fRow[in->IFROff];
  row->atmos = fRow[in->atmosOff];
  row->Datmos = fRow[in->DatmosOff];
  row->GeoDelay = dRow + in->GeoDelayOff;
  row->DopplerOff = fRow + in->DopplerOffOff;
  if (in->numPol>=1) row->MBDelay1 = fRow[in->MBDelay1Off];
  if (in->numPol>=1) row->clock1 = fRow[in->clock1Off];
  if (in->numPol>=1) row->Dclock1 = fRow[in->Dclock1Off];
  if (in->numPol>=1) row->dispers1 = fRow[in->dispers1Off];
  if (in->numPol>=1) row->Ddispers1 = fRow[in->Ddispers1Off];
  if (in->numPol>=1) row->Real1 = fRow + in->Real1Off;
  if (in->numPol>=1) row->Imag1 = fRow + in->Imag1Off;
  if (in->numPol>=1) row->Rate1 = fRow + in->Rate1Off;
  if (in->numPol>=1) row->Delay1 = fRow + in->Delay1Off;
  if (in->numPol>=1) row->Weight1 = fRow + in->Weight1Off;
  if (in->numPol>=1) row->RefAnt1 = iRow + in->RefAnt1Off;
  if (in->numPol>=2) row->MBDelay2 = fRow[in->MBDelay2Off];
  if (in->numPol>=2) row->clock2 = fRow[in->clock2Off];
  if (in->numPol>=2) row->Dclock2 = fRow[in->Dclock2Off];
  if (in->numPol>=2) row->dispers2 = fRow[in->dispers2Off];
  if (in->numPol>=2) row->Ddispers2 = fRow[in->Ddispers2Off];
  if (in->numPol>=2) row->Real2 = fRow + in->Real2Off;
  if (in->numPol>=2) row->Imag2 = fRow + in->Imag2Off;
  if (in->numPol>=2) row->Rate2 = fRow + in->Rate2Off;
  if (in->numPol>=2) row->Delay2 = fRow + in->Delay2Off;
  if (in->numPol>=2) row->Weight2 = fRow + in->Weight2Off;
  if (in->numPol>=2) row->RefAnt2 = iRow + in->RefAnt2Off;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableCLReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableCLSetRow  (ObitTableCL *in, ObitTableCLRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "CL Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->GeoDelay = dRow + in->GeoDelayOff;
  row->DopplerOff = fRow + in->DopplerOffOff;
  if (in->numPol>=1) row->MBDelay1 = fRow[in->MBDelay1Off];
  if (in->numPol>=1) row->clock1 = fRow[in->clock1Off];
  if (in->numPol>=1) row->Dclock1 = fRow[in->Dclock1Off];
  if (in->numPol>=1) row->dispers1 = fRow[in->dispers1Off];
  if (in->numPol>=1) row->Ddispers1 = fRow[in->Ddispers1Off];
  if (in->numPol>=1) row->Real1 = fRow + in->Real1Off;
  if (in->numPol>=1) row->Imag1 = fRow + in->Imag1Off;
  if (in->numPol>=1) row->Rate1 = fRow + in->Rate1Off;
  if (in->numPol>=1) row->Delay1 = fRow + in->Delay1Off;
  if (in->numPol>=1) row->Weight1 = fRow + in->Weight1Off;
  if (in->numPol>=1) row->RefAnt1 = iRow + in->RefAnt1Off;
  if (in->numPol>=2) row->MBDelay2 = fRow[in->MBDelay2Off];
  if (in->numPol>=2) row->clock2 = fRow[in->clock2Off];
  if (in->numPol>=2) row->Dclock2 = fRow[in->Dclock2Off];
  if (in->numPol>=2) row->dispers2 = fRow[in->dispers2Off];
  if (in->numPol>=2) row->Ddispers2 = fRow[in->Ddispers2Off];
  if (in->numPol>=2) row->Real2 = fRow + in->Real2Off;
  if (in->numPol>=2) row->Imag2 = fRow + in->Imag2Off;
  if (in->numPol>=2) row->Rate2 = fRow + in->Rate2Off;
  if (in->numPol>=2) row->Delay2 = fRow + in->Delay2Off;
  if (in->numPol>=2) row->Weight2 = fRow + in->Weight2Off;
  if (in->numPol>=2) row->RefAnt2 = iRow + in->RefAnt2Off;

} /*  end ObitTableCLSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableCLSetRow  
 * \param in       Table to read
 * \param iCLRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableCLWriteRow  (ObitTableCL *in, olong iCLRow, ObitTableCLRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableCLWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS CL Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  fRow[in->TimeIOff] = row->TimeI;
  iRow[in->SourIDOff] = row->SourID;
  iRow[in->antNoOff] = row->antNo;
  iRow[in->SubAOff] = row->SubA;
  iRow[in->FreqIDOff] = row->FreqID;
  fRow[in->IFROff] = row->IFR;
  fRow[in->atmosOff] = row->atmos;
  fRow[in->DatmosOff] = row->Datmos;
  if (in->GeoDelayCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->GeoDelayCol]; i++) 
      dRow[in->GeoDelayOff+i] = row->GeoDelay[i];
  } 
  if (in->DopplerOffCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->DopplerOffCol]; i++) 
      fRow[in->DopplerOffOff+i] = row->DopplerOff[i];
  } 
  if (in->numPol>=1) fRow[in->MBDelay1Off] = row->MBDelay1;
  if (in->numPol>=1) fRow[in->clock1Off] = row->clock1;
  if (in->numPol>=1) fRow[in->Dclock1Off] = row->Dclock1;
  if (in->numPol>=1) fRow[in->dispers1Off] = row->dispers1;
  if (in->numPol>=1) fRow[in->Ddispers1Off] = row->Ddispers1;
  if (in->numPol>=1)
    if (in->Real1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Real1Col]; i++) 
        fRow[in->Real1Off+i] = row->Real1[i];
    } 
  if (in->numPol>=1)
    if (in->Imag1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Imag1Col]; i++) 
        fRow[in->Imag1Off+i] = row->Imag1[i];
    } 
  if (in->numPol>=1)
    if (in->Rate1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Rate1Col]; i++) 
        fRow[in->Rate1Off+i] = row->Rate1[i];
    } 
  if (in->numPol>=1)
    if (in->Delay1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Delay1Col]; i++) 
        fRow[in->Delay1Off+i] = row->Delay1[i];
    } 
  if (in->numPol>=1)
    if (in->Weight1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Weight1Col]; i++) 
        fRow[in->Weight1Off+i] = row->Weight1[i];
    } 
  if (in->numPol>=1)
    if (in->RefAnt1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->RefAnt1Col]; i++) 
        iRow[in->RefAnt1Off+i] = row->RefAnt1[i];
    } 
  if (in->numPol>=2) fRow[in->MBDelay2Off] = row->MBDelay2;
  if (in->numPol>=2) fRow[in->clock2Off] = row->clock2;
  if (in->numPol>=2) fRow[in->Dclock2Off] = row->Dclock2;
  if (in->numPol>=2) fRow[in->dispers2Off] = row->dispers2;
  if (in->numPol>=2) fRow[in->Ddispers2Off] = row->Ddispers2;
  if (in->numPol>=2)
    if (in->Real2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Real2Col]; i++) 
        fRow[in->Real2Off+i] = row->Real2[i];
    } 
  if (in->numPol>=2)
    if (in->Imag2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Imag2Col]; i++) 
        fRow[in->Imag2Off+i] = row->Imag2[i];
    } 
  if (in->numPol>=2)
    if (in->Rate2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Rate2Col]; i++) 
        fRow[in->Rate2Off+i] = row->Rate2[i];
    } 
  if (in->numPol>=2)
    if (in->Delay2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Delay2Col]; i++) 
        fRow[in->Delay2Off+i] = row->Delay2[i];
    } 
  if (in->numPol>=2)
    if (in->Weight2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Weight2Col]; i++) 
        fRow[in->Weight2Off+i] = row->Weight2[i];
    } 
  if (in->numPol>=2)
    if (in->RefAnt2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->RefAnt2Col]; i++) 
        iRow[in->RefAnt2Off+i] = row->RefAnt2[i];
    } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iCLRow */
  retCode = ObitTableWrite ((ObitTable*)in, iCLRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableCLWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableCLClose (ObitTableCL *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableCLClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableCLDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableCLClose */

/*---------------Private functions--------------------------*/
/*----------------  TableCL Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableCLRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCLRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->GeoDelay = NULL;
  in->DopplerOff = NULL;
  in->Real1 = NULL;
  in->Imag1 = NULL;
  in->Rate1 = NULL;
  in->Delay1 = NULL;
  in->Weight1 = NULL;
  in->RefAnt1 = NULL;
  in->Real2 = NULL;
  in->Imag2 = NULL;
  in->Rate2 = NULL;
  in->Delay2 = NULL;
  in->Weight2 = NULL;
  in->RefAnt2 = NULL;

} /* end ObitTableCLRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableCLRow* cast to an Obit*.
 */
void ObitTableCLRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCLRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableCLRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableCLRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableCLRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableCLRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableCLRowClassInfoDefFn (gpointer inClass)
{
  ObitTableCLRowClassInfo *theClass = (ObitTableCLRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableCLRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableCLRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableCLRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableCLRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableCLRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableCLRowInit;

} /* end ObitTableCLRowClassDefFn */

/*------------------  TableCL  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableCLInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCL *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableCLInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableCL* cast to an Obit*.
 */
void ObitTableCLClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCL *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableCLClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableCLClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableCLClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableCLClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableCLClassInfoDefFn (gpointer inClass)
{
  ObitTableCLClassInfo *theClass = (ObitTableCLClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableCLClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableCLClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableCLGetClass;
  theClass->newObit       = (newObitFP)newObitTableCL;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableCLCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableCLClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableCLInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableCLConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableCLOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableCLClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableCLReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableCLWriteRow;

} /* end ObitTableCLClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableCLUpdate (ObitTableCL *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* revision */
  in->revision = 10; 
  ObitInfoListGetTest(in->myDesc->info, "REVISION", &type, dim, 
		       (gpointer)&in->revision);
   /* numPol */
  if (!ObitInfoListGet(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->numPol, err)) return;
   /* numIF */
  if (!ObitInfoListGet(in->myDesc->info, "NO_IF", &type, dim, 
		       (gpointer)&in->numIF, err)) return;
   /* numAnt */
  if (!ObitInfoListGet(in->myDesc->info, "NO_ANT", &type, dim, 
		       (gpointer)&in->numAnt, err)) return;
   /* numTerm */
  in->numTerm = 0; 
  ObitInfoListGetTest(in->myDesc->info, "NO_TERM", &type, dim, 
		       (gpointer)&in->numTerm);
  in->mGMod = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "MGMOD", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->mGMod = InfoReal.dbl;
  if (type==OBIT_float)  in->mGMod = InfoReal.flt;

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->TimeIOff = -1;
  in->TimeICol = -1;
  in->SourIDOff = -1;
  in->SourIDCol = -1;
  in->antNoOff = -1;
  in->antNoCol = -1;
  in->SubAOff = -1;
  in->SubACol = -1;
  in->FreqIDOff = -1;
  in->FreqIDCol = -1;
  in->IFROff = -1;
  in->IFRCol = -1;
  in->GeoDelayOff = -1;
  in->GeoDelayCol = -1;
  in->DopplerOffOff = -1;
  in->DopplerOffCol = -1;
  in->atmosOff = -1;
  in->atmosCol = -1;
  in->DatmosOff = -1;
  in->DatmosCol = -1;
  in->MBDelay1Off = -1;
  in->MBDelay1Col = -1;
  in->clock1Off = -1;
  in->clock1Col = -1;
  in->Dclock1Off = -1;
  in->Dclock1Col = -1;
  in->dispers1Off = -1;
  in->dispers1Col = -1;
  in->Ddispers1Off = -1;
  in->Ddispers1Col = -1;
  in->Real1Off = -1;
  in->Real1Col = -1;
  in->Imag1Off = -1;
  in->Imag1Col = -1;
  in->Rate1Off = -1;
  in->Rate1Col = -1;
  in->Delay1Off = -1;
  in->Delay1Col = -1;
  in->Weight1Off = -1;
  in->Weight1Col = -1;
  in->RefAnt1Off = -1;
  in->RefAnt1Col = -1;
  in->MBDelay2Off = -1;
  in->MBDelay2Col = -1;
  in->clock2Off = -1;
  in->clock2Col = -1;
  in->Dclock2Off = -1;
  in->Dclock2Col = -1;
  in->dispers2Off = -1;
  in->dispers2Col = -1;
  in->Ddispers2Off = -1;
  in->Ddispers2Col = -1;
  in->Real2Off = -1;
  in->Real2Col = -1;
  in->Imag2Off = -1;
  in->Imag2Col = -1;
  in->Rate2Off = -1;
  in->Rate2Col = -1;
  in->Delay2Off = -1;
  in->Delay2Col = -1;
  in->Weight2Off = -1;
  in->Weight2Col = -1;
  in->RefAnt2Off = -1;
  in->RefAnt2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIME INTERVAL", 13)) {
	 in->TimeIOff = desc->offset[i];
 	 in->TimeICol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE ID", 9)) {
	 in->SourIDOff = desc->offset[i];
 	 in->SourIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA NO.", 11)) {
	 in->antNoOff = desc->offset[i];
 	 in->antNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SUBARRAY", 8)) {
	 in->SubAOff = desc->offset[i];
 	 in->SubACol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQ ID", 7)) {
	 in->FreqIDOff = desc->offset[i];
 	 in->FreqIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "I.FAR.ROT", 9)) {
	 in->IFROff = desc->offset[i];
 	 in->IFRCol = i;
      }
      if (!strncmp (desc->FieldName[i], "GEODELAY ", 9)) {
	 in->GeoDelayOff = desc->offset[i];
 	 in->GeoDelayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DOPPOFF  ", 9)) {
	 in->DopplerOffOff = desc->offset[i];
 	 in->DopplerOffCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ATMOS  ", 7)) {
	 in->atmosOff = desc->offset[i];
 	 in->atmosCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DATMOS  ", 8)) {
	 in->DatmosOff = desc->offset[i];
 	 in->DatmosCol = i;
      }
      if (!strncmp (desc->FieldName[i], "MBDELAY1", 8)) {
	     in->MBDelay1Off = desc->offset[i];
 	     in->MBDelay1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "CLOCK 1", 7)) {
	     in->clock1Off = desc->offset[i];
 	     in->clock1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DCLOCK 1", 8)) {
	     in->Dclock1Off = desc->offset[i];
 	     in->Dclock1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DISP 1", 6)) {
	     in->dispers1Off = desc->offset[i];
 	     in->dispers1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DDISP 1", 7)) {
	     in->Ddispers1Off = desc->offset[i];
 	     in->Ddispers1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REAL1", 5)) {
	     in->Real1Off = desc->offset[i];
 	     in->Real1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "IMAG1", 5)) {
	     in->Imag1Off = desc->offset[i];
 	     in->Imag1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "RATE 1", 6)) {
	     in->Rate1Off = desc->offset[i];
 	     in->Rate1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DELAY 1", 7)) {
	     in->Delay1Off = desc->offset[i];
 	     in->Delay1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "WEIGHT 1", 8)) {
	     in->Weight1Off = desc->offset[i];
 	     in->Weight1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REFANT 1", 8)) {
	     in->RefAnt1Off = desc->offset[i];
 	     in->RefAnt1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "MBDELAY2", 8)) {
	     in->MBDelay2Off = desc->offset[i];
 	     in->MBDelay2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "CLOCK 2", 7)) {
	     in->clock2Off = desc->offset[i];
 	     in->clock2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DCLOCK 2", 8)) {
	     in->Dclock2Off = desc->offset[i];
 	     in->Dclock2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DISP 2", 6)) {
	     in->dispers2Off = desc->offset[i];
 	     in->dispers2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DDISP 2", 7)) {
	     in->Ddispers2Off = desc->offset[i];
 	     in->Ddispers2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REAL2", 5)) {
	     in->Real2Off = desc->offset[i];
 	     in->Real2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "IMAG2", 5)) {
	     in->Imag2Off = desc->offset[i];
 	     in->Imag2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "RATE 2", 6)) {
	     in->Rate2Off = desc->offset[i];
 	     in->Rate2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DELAY 2", 7)) {
	     in->Delay2Off = desc->offset[i];
 	     in->Delay2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "WEIGHT 2", 8)) {
	     in->Weight2Off = desc->offset[i];
 	     in->Weight2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REFANT 2", 8)) {
	     in->RefAnt2Off = desc->offset[i];
 	     in->RefAnt2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableCLUpdate: Could not find column Time");
  Obit_return_if_fail((in->TimeIOff > -1), err,
       "ObitTableCLUpdate: Could not find column TimeI");
  Obit_return_if_fail((in->SourIDOff > -1), err,
       "ObitTableCLUpdate: Could not find column SourID");
  Obit_return_if_fail((in->antNoOff > -1), err,
       "ObitTableCLUpdate: Could not find column antNo");
  Obit_return_if_fail((in->SubAOff > -1), err,
       "ObitTableCLUpdate: Could not find column SubA");
  Obit_return_if_fail((in->FreqIDOff > -1), err,
       "ObitTableCLUpdate: Could not find column FreqID");
  Obit_return_if_fail((in->IFROff > -1), err,
       "ObitTableCLUpdate: Could not find column IFR");
  Obit_return_if_fail((in->GeoDelayOff > -1), err,
       "ObitTableCLUpdate: Could not find column GeoDelay");
  Obit_return_if_fail((in->DopplerOffOff > -1), err,
       "ObitTableCLUpdate: Could not find column DopplerOff");
  Obit_return_if_fail((in->atmosOff > -1), err,
       "ObitTableCLUpdate: Could not find column atmos");
  Obit_return_if_fail((in->DatmosOff > -1), err,
       "ObitTableCLUpdate: Could not find column Datmos");
  if (in->numPol>=1) {
    Obit_return_if_fail((in->MBDelay1Off > -1), err,
       "ObitTableCLUpdate: Could not find column MBDelay1");
    Obit_return_if_fail((in->clock1Off > -1), err,
       "ObitTableCLUpdate: Could not find column clock1");
    Obit_return_if_fail((in->Dclock1Off > -1), err,
       "ObitTableCLUpdate: Could not find column Dclock1");
    Obit_return_if_fail((in->dispers1Off > -1), err,
       "ObitTableCLUpdate: Could not find column dispers1");
    Obit_return_if_fail((in->Ddispers1Off > -1), err,
       "ObitTableCLUpdate: Could not find column Ddispers1");
    Obit_return_if_fail((in->Real1Off > -1), err,
       "ObitTableCLUpdate: Could not find column Real1");
    Obit_return_if_fail((in->Imag1Off > -1), err,
       "ObitTableCLUpdate: Could not find column Imag1");
    Obit_return_if_fail((in->Rate1Off > -1), err,
       "ObitTableCLUpdate: Could not find column Rate1");
    Obit_return_if_fail((in->Delay1Off > -1), err,
       "ObitTableCLUpdate: Could not find column Delay1");
    Obit_return_if_fail((in->Weight1Off > -1), err,
       "ObitTableCLUpdate: Could not find column Weight1");
  } /* end of if index in range */
  if (in->numPol>=2) {
    Obit_return_if_fail((in->MBDelay2Off > -1), err,
       "ObitTableCLUpdate: Could not find column MBDelay2");
    Obit_return_if_fail((in->clock2Off > -1), err,
       "ObitTableCLUpdate: Could not find column clock2");
    Obit_return_if_fail((in->Dclock2Off > -1), err,
       "ObitTableCLUpdate: Could not find column Dclock2");
    Obit_return_if_fail((in->dispers2Off > -1), err,
       "ObitTableCLUpdate: Could not find column dispers2");
    Obit_return_if_fail((in->Ddispers2Off > -1), err,
       "ObitTableCLUpdate: Could not find column Ddispers2");
    Obit_return_if_fail((in->Real2Off > -1), err,
       "ObitTableCLUpdate: Could not find column Real2");
    Obit_return_if_fail((in->Imag2Off > -1), err,
       "ObitTableCLUpdate: Could not find column Imag2");
    Obit_return_if_fail((in->Rate2Off > -1), err,
       "ObitTableCLUpdate: Could not find column Rate2");
    Obit_return_if_fail((in->Delay2Off > -1), err,
       "ObitTableCLUpdate: Could not find column Delay2");
    Obit_return_if_fail((in->Weight2Off > -1), err,
       "ObitTableCLUpdate: Could not find column Weight2");
  } /* end of if index in range */
} /* end ObitTableCLUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableCLDumpKey (ObitTableCL *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
  else info = in->myDesc->info;
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REVISION", type, dim, 
		  (gpointer)&in->revision);
  /* numPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->numPol);
  /* numIF */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_IF", type, dim, 
		  (gpointer)&in->numIF);
  /* numAnt */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_ANT", type, dim, 
		  (gpointer)&in->numAnt);
  /* numTerm */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_TERM", type, dim, 
		  (gpointer)&in->numTerm);
  /* mGMod */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "MGMOD", type, dim, 
		  (gpointer)&in->mGMod);
   
} /* end ObitTableCLDumpKey */
