/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2010                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableMC.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableMC.c
 * ObitTableMC class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableMC";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableMCRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableMCRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableMCClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableMCClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableMCRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableMCRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableMCInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableMCClear (gpointer in);

/** Private: update table specific info */
static void ObitTableMCUpdate (ObitTableMC *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableMCDumpKey (ObitTableMC *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableMCClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableMCRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableMCRow* newObitTableMCRow (ObitTableMC *table)
{
  ObitTableMCRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableMCRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableMCRow));

  /* initialize values */
  out->name = g_strdup("TableMC Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableMCRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    if (table->numPol>=1) out->clock1 = dRow[table->clock1Off];
    if (table->numPol>=1) out->Dclock1 = dRow[table->Dclock1Off];
    if (table->numPol>=1) out->LOOffset1 = fRow[table->LOOffset1Off];
    if (table->numPol>=1) out->DLOOffset1 = fRow[table->DLOOffset1Off];
    if (table->numPol>=1) out->disp1 = fRow[table->disp1Off];
    if (table->numPol>=1) out->Ddisp1 = fRow[table->Ddisp1Off];
    if (table->numPol>=2) out->clock2 = dRow[table->clock2Off];
    if (table->numPol>=2) out->Dclock2 = dRow[table->Dclock2Off];
    if (table->numPol>=2) out->LOOffset2 = fRow[table->LOOffset2Off];
    if (table->numPol>=2) out->DLOOffset2 = fRow[table->DLOOffset2Off];
    if (table->numPol>=2) out->disp2 = fRow[table->disp2Off];
    if (table->numPol>=2) out->Ddisp2 = fRow[table->Ddisp2Off];
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableMCRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableMCRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableMCRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableMCRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableMC* newObitTableMC (gchar* name)
{
  ObitTableMC* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableMCClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableMC));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableMCInit((gpointer)out);

 return out;
} /* end newObitTableMC */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableMCGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableMCClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitMCGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numPol The number of polarizations.
 * \param numBand The number of Bands(?).
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableMC* newObitTableMCValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numPol, oint numBand,
		     ObitErr *err)
{
  ObitTableMC* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS MC";
  gchar *routine = "newObitTableMCValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableMCClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS MC");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableMC */
      if (ObitTableMCIsA(testTab)) { /* it is an ObitTableMC */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableMCConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS MC");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableMCIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableMCConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numPol = MAX (0, numPol);
  out->numBand = MAX (0, numBand);
  strncpy (out->obscode, "AA000", MAXKEYCHARTABLEMC );
  strncpy (out->RefDate, "YYYYMMDD", MAXKEYCHARTABLEMC );
  out->revision = 1;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 9 + out->numPol*6 + out->numBand*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCE_ID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA_NO");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ARRAY      ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ATMOS  ");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DATMOS  ");
  desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("GDELAY");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("GRATE ");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("CLOCK_1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DCLOCK_1");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("LO_OFFSET_1");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DLO_OFFSET_1");
    desc->FieldUnit[colNo] = g_strdup("Hz/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DISP_1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DDISP_1");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("CLOCK_2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DCLOCK_2");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("LO_OFFSET_2");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DLO_OFFSET_2");
    desc->FieldUnit[colNo] = g_strdup("Hz/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DISP_2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DDISP_2");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableMCDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableMCOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableMCClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableMCValue */

/**
 * Convert an ObitTable to an ObitTableMC.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableMC* ObitTableMCConvert (ObitTable* in)
{
  ObitTableMC *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableMC(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableMCConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableMC* ObitTableMCCopy (ObitTableMC *in, ObitTableMC *out, ObitErr *err)
{
  gchar *routine = "ObitTableMCCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableMCClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableMC*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLEMC );
  out->numPol = in->numPol;
  strncpy (out->RefDate, in->RefDate, MAXKEYCHARTABLEMC );
  out->numStkd = in->numStkd;
  out->stk1 = in->stk1;
  out->numBand = in->numBand;
  out->numChan = in->numChan;
  out->refFreq = in->refFreq;
  out->chanBW = in->chanBW;
  out->refPixl = in->refPixl;
  out->FFTSize = in->FFTSize;
  out->oversamp = in->oversamp;
  out->zeroPad = in->zeroPad;
  strncpy (out->taperFn, in->taperFn, MAXKEYCHARTABLEMC );
  out->revision = in->revision;
  /* Update class specific info */
  ObitTableMCUpdate (out, err);
    
  return out;
} /* end ObitTableMCCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableMCOpen (ObitTableMC *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableMCOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableMCClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableMCUpdate (in, err);
   
   return retCode;
} /* end ObitTableMCOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iMCRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableMCReadRow  (ObitTableMC *in, olong iMCRow, ObitTableMCRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableMCReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS MC Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iMCRow */
  retCode = ObitTableRead ((ObitTable*)in, iMCRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->SourID = iRow[in->SourIDOff];
  row->antennaNo = iRow[in->antennaNoOff];
  row->Array = iRow[in->ArrayOff];
  row->FreqID = iRow[in->FreqIDOff];
  row->atmos = dRow[in->atmosOff];
  row->Datmos = dRow[in->DatmosOff];
  row->GDelay = dRow[in->GDelayOff];
  row->GRate = dRow[in->GRateOff];
  if (in->numPol>=1) row->clock1 = dRow[in->clock1Off];
  if (in->numPol>=1) row->Dclock1 = dRow[in->Dclock1Off];
  if (in->numPol>=1) row->LOOffset1 = fRow[in->LOOffset1Off];
  if (in->numPol>=1) row->DLOOffset1 = fRow[in->DLOOffset1Off];
  if (in->numPol>=1) row->disp1 = fRow[in->disp1Off];
  if (in->numPol>=1) row->Ddisp1 = fRow[in->Ddisp1Off];
  if (in->numPol>=2) row->clock2 = dRow[in->clock2Off];
  if (in->numPol>=2) row->Dclock2 = dRow[in->Dclock2Off];
  if (in->numPol>=2) row->LOOffset2 = fRow[in->LOOffset2Off];
  if (in->numPol>=2) row->DLOOffset2 = fRow[in->DLOOffset2Off];
  if (in->numPol>=2) row->disp2 = fRow[in->disp2Off];
  if (in->numPol>=2) row->Ddisp2 = fRow[in->Ddisp2Off];
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableMCReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableMCSetRow  (ObitTableMC *in, ObitTableMCRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "MC Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  if (in->numPol>=1) row->clock1 = dRow[in->clock1Off];
  if (in->numPol>=1) row->Dclock1 = dRow[in->Dclock1Off];
  if (in->numPol>=1) row->LOOffset1 = fRow[in->LOOffset1Off];
  if (in->numPol>=1) row->DLOOffset1 = fRow[in->DLOOffset1Off];
  if (in->numPol>=1) row->disp1 = fRow[in->disp1Off];
  if (in->numPol>=1) row->Ddisp1 = fRow[in->Ddisp1Off];
  if (in->numPol>=2) row->clock2 = dRow[in->clock2Off];
  if (in->numPol>=2) row->Dclock2 = dRow[in->Dclock2Off];
  if (in->numPol>=2) row->LOOffset2 = fRow[in->LOOffset2Off];
  if (in->numPol>=2) row->DLOOffset2 = fRow[in->DLOOffset2Off];
  if (in->numPol>=2) row->disp2 = fRow[in->disp2Off];
  if (in->numPol>=2) row->Ddisp2 = fRow[in->Ddisp2Off];

} /*  end ObitTableMCSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableMCSetRow  
 * \param in       Table to read
 * \param iMCRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableMCWriteRow  (ObitTableMC *in, olong iMCRow, ObitTableMCRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableMCWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS MC Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  iRow[in->SourIDOff] = row->SourID;
  iRow[in->antennaNoOff] = row->antennaNo;
  iRow[in->ArrayOff] = row->Array;
  iRow[in->FreqIDOff] = row->FreqID;
  dRow[in->atmosOff] = row->atmos;
  dRow[in->DatmosOff] = row->Datmos;
  dRow[in->GDelayOff] = row->GDelay;
  dRow[in->GRateOff] = row->GRate;
  if (in->numPol>=1) dRow[in->clock1Off] = row->clock1;
  if (in->numPol>=1) dRow[in->Dclock1Off] = row->Dclock1;
  if (in->numPol>=1) fRow[in->LOOffset1Off] = row->LOOffset1;
  if (in->numPol>=1) fRow[in->DLOOffset1Off] = row->DLOOffset1;
  if (in->numPol>=1) fRow[in->disp1Off] = row->disp1;
  if (in->numPol>=1) fRow[in->Ddisp1Off] = row->Ddisp1;
  if (in->numPol>=2) dRow[in->clock2Off] = row->clock2;
  if (in->numPol>=2) dRow[in->Dclock2Off] = row->Dclock2;
  if (in->numPol>=2) fRow[in->LOOffset2Off] = row->LOOffset2;
  if (in->numPol>=2) fRow[in->DLOOffset2Off] = row->DLOOffset2;
  if (in->numPol>=2) fRow[in->disp2Off] = row->disp2;
  if (in->numPol>=2) fRow[in->Ddisp2Off] = row->Ddisp2;

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iMCRow */
  retCode = ObitTableWrite ((ObitTable*)in, iMCRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableMCWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableMCClose (ObitTableMC *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableMCClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableMCDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableMCClose */

/*---------------Private functions--------------------------*/
/*----------------  TableMC Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableMCRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableMCRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */

} /* end ObitTableMCRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableMCRow* cast to an Obit*.
 */
void ObitTableMCRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableMCRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableMCRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableMCRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableMCRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableMCRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableMCRowClassInfoDefFn (gpointer inClass)
{
  ObitTableMCRowClassInfo *theClass = (ObitTableMCRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableMCRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableMCRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableMCRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableMCRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableMCRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableMCRowInit;

} /* end ObitTableMCRowClassDefFn */

/*------------------  TableMC  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableMCInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableMC *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableMCInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableMC* cast to an Obit*.
 */
void ObitTableMCClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableMC *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableMCClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableMCClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableMCClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableMCClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableMCClassInfoDefFn (gpointer inClass)
{
  ObitTableMCClassInfo *theClass = (ObitTableMCClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableMCClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableMCClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableMCGetClass;
  theClass->newObit       = (newObitFP)newObitTableMC;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableMCCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableMCClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableMCInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableMCConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableMCOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableMCClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableMCReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableMCWriteRow;

} /* end ObitTableMCClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableMCUpdate (ObitTableMC *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* obscode */
  strncpy (in->obscode, "AA000", MAXKEYCHARTABLEMC); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);
   /* numPol */
  if (!ObitInfoListGet(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->numPol, err)) return;
   /* RefDate */
  strncpy (in->RefDate, "YYYYMMDD", MAXKEYCHARTABLEMC); 
  ObitInfoListGetTest(in->myDesc->info, "RDATE", &type, dim, 
		       (gpointer)&in->RefDate);
   /* numStkd */
  if (!ObitInfoListGet(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->numStkd, err)) return;
   /* stk1 */
  if (!ObitInfoListGet(in->myDesc->info, "STK_1", &type, dim, 
		       (gpointer)&in->stk1, err)) return;
   /* numBand */
  if (!ObitInfoListGet(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->numBand, err)) return;
   /* numChan */
  if (!ObitInfoListGet(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->numChan, err)) return;
   /* refFreq */
  if (!ObitInfoListGet(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->refFreq = InfoReal.dbl;
  if (type==OBIT_float)  in->refFreq = InfoReal.flt;
   /* chanBW */
  if (!ObitInfoListGet(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->chanBW = InfoReal.dbl;
  if (type==OBIT_float)  in->chanBW = InfoReal.flt;
   /* refPixl */
  if (!ObitInfoListGet(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->refPixl = InfoReal.dbl;
  if (type==OBIT_float)  in->refPixl = InfoReal.flt;
   /* FFTSize */
  if (!ObitInfoListGet(in->myDesc->info, "FFT_SIZE", &type, dim, 
		       (gpointer)&in->FFTSize, err)) return;
   /* oversamp */
  if (!ObitInfoListGet(in->myDesc->info, "OVERSAMP", &type, dim, 
		       (gpointer)&in->oversamp, err)) return;
   /* zeroPad */
  if (!ObitInfoListGet(in->myDesc->info, "ZERO_PAD", &type, dim, 
		       (gpointer)&in->zeroPad, err)) return;
   /* taperFn */
  if (!ObitInfoListGet(in->myDesc->info, "TAPER_FN", &type, dim, 
		       (gpointer)&in->taperFn, err)) return;
   /* revision */
  in->revision = 1; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->revision);

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->SourIDOff = -1;
  in->SourIDCol = -1;
  in->antennaNoOff = -1;
  in->antennaNoCol = -1;
  in->ArrayOff = -1;
  in->ArrayCol = -1;
  in->FreqIDOff = -1;
  in->FreqIDCol = -1;
  in->atmosOff = -1;
  in->atmosCol = -1;
  in->DatmosOff = -1;
  in->DatmosCol = -1;
  in->GDelayOff = -1;
  in->GDelayCol = -1;
  in->GRateOff = -1;
  in->GRateCol = -1;
  in->clock1Off = -1;
  in->clock1Col = -1;
  in->Dclock1Off = -1;
  in->Dclock1Col = -1;
  in->LOOffset1Off = -1;
  in->LOOffset1Col = -1;
  in->DLOOffset1Off = -1;
  in->DLOOffset1Col = -1;
  in->disp1Off = -1;
  in->disp1Col = -1;
  in->Ddisp1Off = -1;
  in->Ddisp1Col = -1;
  in->clock2Off = -1;
  in->clock2Col = -1;
  in->Dclock2Off = -1;
  in->Dclock2Col = -1;
  in->LOOffset2Off = -1;
  in->LOOffset2Col = -1;
  in->DLOOffset2Off = -1;
  in->DLOOffset2Col = -1;
  in->disp2Off = -1;
  in->disp2Col = -1;
  in->Ddisp2Off = -1;
  in->Ddisp2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE_ID  ", 11)) {
	 in->SourIDOff = desc->offset[i];
 	 in->SourIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA_NO", 10)) {
	 in->antennaNoOff = desc->offset[i];
 	 in->antennaNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ARRAY      ", 11)) {
	 in->ArrayOff = desc->offset[i];
 	 in->ArrayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQID", 6)) {
	 in->FreqIDOff = desc->offset[i];
 	 in->FreqIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ATMOS  ", 7)) {
	 in->atmosOff = desc->offset[i];
 	 in->atmosCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DATMOS  ", 8)) {
	 in->DatmosOff = desc->offset[i];
 	 in->DatmosCol = i;
      }
      if (!strncmp (desc->FieldName[i], "GDELAY", 6)) {
	 in->GDelayOff = desc->offset[i];
 	 in->GDelayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "GRATE ", 6)) {
	 in->GRateOff = desc->offset[i];
 	 in->GRateCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CLOCK_1", 7)) {
	     in->clock1Off = desc->offset[i];
 	     in->clock1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DCLOCK_1", 8)) {
	     in->Dclock1Off = desc->offset[i];
 	     in->Dclock1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "LO_OFFSET_1", 11)) {
	     in->LOOffset1Off = desc->offset[i];
 	     in->LOOffset1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DLO_OFFSET_1", 12)) {
	     in->DLOOffset1Off = desc->offset[i];
 	     in->DLOOffset1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DISP_1", 6)) {
	     in->disp1Off = desc->offset[i];
 	     in->disp1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DDISP_1", 7)) {
	     in->Ddisp1Off = desc->offset[i];
 	     in->Ddisp1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "CLOCK_2", 7)) {
	     in->clock2Off = desc->offset[i];
 	     in->clock2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DCLOCK_2", 8)) {
	     in->Dclock2Off = desc->offset[i];
 	     in->Dclock2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "LO_OFFSET_2", 11)) {
	     in->LOOffset2Off = desc->offset[i];
 	     in->LOOffset2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DLO_OFFSET_2", 12)) {
	     in->DLOOffset2Off = desc->offset[i];
 	     in->DLOOffset2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DISP_2", 6)) {
	     in->disp2Off = desc->offset[i];
 	     in->disp2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DDISP_2", 7)) {
	     in->Ddisp2Off = desc->offset[i];
 	     in->Ddisp2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableMCUpdate: Could not find column Time");
  Obit_return_if_fail((in->SourIDOff > -1), err,
       "ObitTableMCUpdate: Could not find column SourID");
  Obit_return_if_fail((in->antennaNoOff > -1), err,
       "ObitTableMCUpdate: Could not find column antennaNo");
  Obit_return_if_fail((in->ArrayOff > -1), err,
       "ObitTableMCUpdate: Could not find column Array");
  Obit_return_if_fail((in->FreqIDOff > -1), err,
       "ObitTableMCUpdate: Could not find column FreqID");
  Obit_return_if_fail((in->atmosOff > -1), err,
       "ObitTableMCUpdate: Could not find column atmos");
  Obit_return_if_fail((in->DatmosOff > -1), err,
       "ObitTableMCUpdate: Could not find column Datmos");
  Obit_return_if_fail((in->GDelayOff > -1), err,
       "ObitTableMCUpdate: Could not find column GDelay");
  Obit_return_if_fail((in->GRateOff > -1), err,
       "ObitTableMCUpdate: Could not find column GRate");
  if (in->numPol>=1) {
    Obit_return_if_fail((in->clock1Off > -1), err,
       "ObitTableMCUpdate: Could not find column clock1");
    Obit_return_if_fail((in->Dclock1Off > -1), err,
       "ObitTableMCUpdate: Could not find column Dclock1");
    Obit_return_if_fail((in->LOOffset1Off > -1), err,
       "ObitTableMCUpdate: Could not find column LOOffset1");
    Obit_return_if_fail((in->DLOOffset1Off > -1), err,
       "ObitTableMCUpdate: Could not find column DLOOffset1");
    Obit_return_if_fail((in->disp1Off > -1), err,
       "ObitTableMCUpdate: Could not find column disp1");
  } /* end of if index in range */
  if (in->numPol>=2) {
    Obit_return_if_fail((in->clock2Off > -1), err,
       "ObitTableMCUpdate: Could not find column clock2");
    Obit_return_if_fail((in->Dclock2Off > -1), err,
       "ObitTableMCUpdate: Could not find column Dclock2");
    Obit_return_if_fail((in->LOOffset2Off > -1), err,
       "ObitTableMCUpdate: Could not find column LOOffset2");
    Obit_return_if_fail((in->DLOOffset2Off > -1), err,
       "ObitTableMCUpdate: Could not find column DLOOffset2");
    Obit_return_if_fail((in->disp2Off > -1), err,
       "ObitTableMCUpdate: Could not find column disp2");
  } /* end of if index in range */
} /* end ObitTableMCUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableMCDumpKey (ObitTableMC *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
  else info = in->myDesc->info;
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEMC;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
  /* numPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->numPol);
  /* RefDate */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEMC;
  ObitInfoListAlwaysPut(info, "RDATE", type, dim, 
		  (gpointer)&in->RefDate);
  /* numStkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->numStkd);
  /* stk1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STK_1", type, dim, 
		  (gpointer)&in->stk1);
  /* numBand */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->numBand);
  /* numChan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->numChan);
  /* refFreq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->refFreq);
  /* chanBW */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chanBW);
  /* refPixl */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->refPixl);
  /* FFTSize */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "FFT_SIZE", type, dim, 
		  (gpointer)&in->FFTSize);
  /* oversamp */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "OVERSAMP", type, dim, 
		  (gpointer)&in->oversamp);
  /* zeroPad */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "ZERO_PAD", type, dim, 
		  (gpointer)&in->zeroPad);
  /* taperFn */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEMC;
  ObitInfoListAlwaysPut(info, "TAPER_FN", type, dim, 
		  (gpointer)&in->taperFn);
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->revision);
   
} /* end ObitTableMCDumpKey */
